package consts

import (
	"ORsearch/utilities"
)

// The number of columns of the matrix
const N = 7

// Choose the number of predefined initial rows we should take (according to structures.InitialRows())
// (The first and second rows can be set to all zeros and all ones respectively WLOG)
// (For all n <= 7, the 4 first rows of the extremal matrices always have the same structure)
const INITIALROWS = 4

// For distributed search: 
// every worker launches the branch search algorithm with an initial matrix of DISTRIBUTIONLEVEL rows
const DISTRIBUTIONROWS = 9

// Cut any branch that is provably unable to reach at least CUTATUPDATE distinct rows
// (Based on the cutting lemma)
var CUTATUPDATE = utilities.Fibonacci(N+2)

// Display sub-steps of the search
// -1 : no display
// 0 : only the number of branches and the new records
// 1 : also display matrices found with BESTMATRIXINSTANTREPORT or more rows and the progress every PROGRESSFREQUENCY searched branches
// 2 : also display when a branch is launched, finished or cut
const DISPLAY = 1
var BESTMATRIXINSTANTREPORT = utilities.Fibonacci(N+2)-1
const PROGRESSFREQUENCY = 5000

// For distributed search:
// Number of threads supposed to be running in parallel
const PARALLELTHREADS = 4
