package structures

import (
	"fmt"
)

type Matrix struct {
	rows, cols int
	Elems []uint16
}

func NewMatrix(M, N int) *Matrix {
	m := new(Matrix)
	m.rows = M
	m.cols = N
	m.Elems = make([]uint16, M)
	return m
}

func NewEmptyMatrix() *Matrix {
 	m := NewMatrix(0, 0)
 	return m
}

func (m *Matrix) Display() {
	for _,row := range m.Elems {
		format := fmt.Sprintf("0%db\n", m.cols)
		fmt.Printf("%"+format, row)
	}
	fmt.Printf("\n");
}

func (m *Matrix) Copy(src *Matrix) {
	copy(m.Elems, src.Elems)
	m.rows = src.rows
	m.cols = src.cols
}